/*!
 * Module For Query (m4q, https://metroui.org.ua)
 * Copyright 2012-2024 by Serhii Pimenov
 * Licensed under MIT
 !*/
!function(){"use strict";var t=["opacity","zIndex"];function isVisible(t){return!!(t.offsetWidth||t.offsetHeight||t.getClientRects().length)}function not(t){return null==t}function camelCase(t){return t.replace(/-([a-z])/g,(function(t,e){return e.toUpperCase()}))}function isPlainObject(t){var e;return!(!t||"[object Object]"!==Object.prototype.toString.call(t))&&(!(e=void 0!==t.prototype)||e.constructor&&"function"==typeof e.constructor)}function isEmptyObject(t){for(var e in t)if(hasProp(t,e))return!1;return!0}function isArrayLike(t){return t instanceof Object&&"length"in t}function str2arr(t,e){return e=e||" ",t.split(e).map((function(t){return(""+t).trim()})).filter((function(t){return""!==t}))}function parseUnit(t,e){return e||(e=[0,""]),t=String(t),e[0]=parseFloat(t),e[1]=t.match(/[\d.\-+]*\s*(.*)/)[1]||"",e}function getUnit(t,e){var n=/[+-]?\d*\.?\d+(?:\.\d+)?(?:[eE][+-]?\d+)?(%|px|pt|em|rem|in|cm|mm|ex|ch|pc|vw|vh|vmin|vmax|deg|rad|turn)?$/.exec(t);return void 0!==n[1]?n[1]:e}function setStyleProp(e,n,i){n=camelCase(n),["scrollLeft","scrollTop"].indexOf(n)>-1?e[n]=parseInt(i):e.style[n]=isNaN(i)||t.indexOf(""+n)>-1?i:i+"px"}function acceptData(t){return 1===t.nodeType||9===t.nodeType||!+t.nodeType}function dataAttr(t,e,n){var o;return not(n)&&1===t.nodeType&&(o="data-"+e.replace(/[A-Z]/g,"-$&").toLowerCase(),"string"==typeof(n=t.getAttribute(o))?(n=function getData(t){try{return JSON.parse(t)}catch(e){return t}}(n),i.set(t,e,n)):n=void 0),n}function normName(t){return"string"!=typeof t?void 0:t.replace(/-/g,"").toLowerCase()}function hasProp(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function isLocalhost(t){var e=t||window.location.hostname;return"localhost"===e||"127.0.0.1"===e||"[::1]"===e||""===e||null!==e.match(/^127(?:\.(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)){3}$/)}!function(t){if(!t.setImmediate){var e,n=1,i={},o=!1,r=Object.getPrototypeOf&&Object.getPrototypeOf(t);r=r&&r.setTimeout?r:t,"[object process]"==={}.toString.call(t.process)?function installNextTickImplementation(){e=function(e){t.process.nextTick((function(){runIfPresent(e)}))}}():t.MessageChannel?function installMessageChannelImplementation(){var t=new MessageChannel;t.port1.onmessage=function(t){runIfPresent(t.data)},e=function(e){t.port2.postMessage(e)}}():function installPostMessageImplementation(){var n="setImmediate$"+Math.random()+"$";t.addEventListener("message",(function(e){e.source===t&&"string"==typeof e.data&&0===e.data.indexOf(n)&&runIfPresent(+e.data.slice(n.length))}),!1),e=function(e){t.postMessage(n+e,"*")}}(),r.setImmediate=function setImmediate(t){"function"!=typeof t&&(t=new Function(""+t));for(var o=new Array(arguments.length-1),r=0;r<o.length;r++)o[r]=arguments[r+1];return i[n]={callback:t,args:o},e(n),n++},r.clearImmediate=clearImmediate}function clearImmediate(t){delete i[t]}function runIfPresent(t){if(o)setTimeout(runIfPresent,0,t);else{var e=i[t];if(e){o=!0;try{!function run(t){var e=t.callback,n=t.args;switch(n.length){case 0:e();break;case 1:e(n[0]);break;case 2:e(n[0],n[1]);break;case 3:e(n[0],n[1],n[2]);break;default:e.apply(void 0,n)}}(e)}finally{clearImmediate(t),o=!1}}}}}("undefined"==typeof self?"undefined"==typeof global?window:global:self),function(t){if(!t.Promise){var e,n="pending",i="sealed",o="fulfilled",r="rejected",NOOP=function(){},a="undefined"!=typeof setImmediate?setImmediate:setTimeout,s=[];Promise.prototype={constructor:Promise,state_:n,then_:null,data_:void 0,then:function(t,e){var n={owner:this,then:new this.constructor(NOOP),fulfilled:t,rejected:e};return this.state_===o||this.state_===r?asyncCall(invokeCallback,n):this.then_.push(n),n.then},done:function(t){return this.then(t,null)},always:function(t){return this.then(t,t)},catch:function(t){return this.then(null,t)}},Promise.all=function(t){if(!isArray(t))throw new TypeError("You must pass an array to Promise.all().");return new this((function(e,n){var i=[],o=0;function resolver(t){return o++,function(n){i[t]=n,--o||e(i)}}for(var r,a=0;a<t.length;a++)(r=t[a])&&"function"==typeof r.then?r.then(resolver(a),n):i[a]=r;o||e(i)}))},Promise.race=function(t){if(!isArray(t))throw new TypeError("You must pass an array to Promise.race().");return new this((function(e,n){for(var i,o=0;o<t.length;o++)(i=t[o])&&"function"==typeof i.then?i.then(e,n):e(i)}))},Promise.resolve=function(t){return t&&"object"==typeof t&&t.constructor===this?t:new this((function(e){e(t)}))},Promise.reject=function(t){return new this((function(e,n){n(t)}))},void 0===t.Promise&&(t.Promise=Promise)}function isArray(t){return"[object Array]"===Object.prototype.toString.call(t)}function asyncFlush(){for(var t=0;t<s.length;t++)s[t][0](s[t][1]);s=[],e=!1}function asyncCall(t,n){s.push([t,n]),e||(e=!0,a(asyncFlush,0))}function invokeCallback(t){var e=t.owner,n=e.state_,i=e.data_,a=t[n],s=t.then;if("function"==typeof a){n=o;try{i=a(i)}catch(t){reject(s,t)}}handleThenable(s,i)||(n===o&&resolve(s,i),n===r&&reject(s,i))}function handleThenable(t,e){var n;try{if(t===e)throw new TypeError("A promises callback cannot return that same promise.");if(e&&("function"==typeof e||"object"==typeof e)){var i=e.then;if("function"==typeof i)return i.call(e,(function(i){n||(n=!0,e!==i?resolve(t,i):fulfill(t,i))}),(function(e){n||(n=!0,reject(t,e))})),!0}}catch(e){return n||reject(t,e),!0}return!1}function resolve(t,e){t!==e&&handleThenable(t,e)||fulfill(t,e)}function fulfill(t,e){t.state_===n&&(t.state_=i,t.data_=e,asyncCall(publishFulfillment,t))}function reject(t,e){t.state_===n&&(t.state_=i,t.data_=e,asyncCall(publishRejection,t))}function publish(t){var e=t.then_;t.then_=void 0;for(var n=0;n<e.length;n++)invokeCallback(e[n])}function publishFulfillment(t){t.state_=o,publish(t)}function publishRejection(t){t.state_=r,publish(t)}function Promise(t){if("function"!=typeof t)throw new TypeError("Promise constructor takes a function argument");if(!(this instanceof Promise))throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.");this.then_=[],function invokeResolver(t,e){function rejectPromise(t){reject(e,t)}try{t((function resolvePromise(t){resolve(e,t)}),rejectPromise)}catch(t){rejectPromise(t)}}(t,this)}}(window);var e="v1.2.2",n=Element.prototype.matches||Element.prototype.matchesSelector||Element.prototype.webkitMatchesSelector||Element.prototype.mozMatchesSelector||Element.prototype.msMatchesSelector||Element.prototype.oMatchesSelector;globalThis.$=function(t,e){return new $.init(t,e)},$.version=e,$.fn=$.prototype={version:e,constructor:$,length:0,uid:"",push:[].push,sort:[].sort,splice:[].splice,indexOf:[].indexOf,reverse:[].reverse},$.extend=$.fn.extend=function(){var t,e,n=arguments[0]||{},i=1,o=arguments.length;for("object"!=typeof n&&"function"!=typeof n&&(n={}),i===o&&(n=this,i--);i<o;i++)if(null!=(t=arguments[i]))for(e in t)hasProp(t,e)&&(n[e]=t[e]);return n},$.assign=function(){var t,e,n=arguments[0]||{},i=1,o=arguments.length;for("object"!=typeof n&&"function"!=typeof n&&(n={}),i===o&&(n=this,i--);i<o;i++)if(null!=(t=arguments[i]))for(e in t)hasProp(t,e)&&void 0!==t[e]&&(n[e]=t[e]);return n};var now=function(){return Date.now()};function createScript(t){var e=document.createElement("script");if(e.type="text/javascript",not(t))return $(e);var n=$(t)[0];return n.src?e.src=n.src:e.textContent=n.innerText,document.body.appendChild(e),n.parentNode&&n.parentNode.removeChild(n),e}$.extend({intervalId:-1,intervalQueue:[],intervalTicking:!1,intervalTickId:null,setInterval:function(t,e){var n=this;if(this.intervalId++,this.intervalQueue.push({id:this.intervalId,fn:t,interval:e,lastTime:now()}),!this.intervalTicking){var tick=function(){n.intervalTickId=requestAnimationFrame(tick),$.each(n.intervalQueue,(function(){var t=this;(t.interval<17||now()-t.lastTime>=t.interval)&&(t.fn(),t.lastTime=now())}))};this.intervalTicking=!0,tick()}return this.intervalId},clearInterval:function(t){for(var e=0;e<this.intervalQueue.length;e++)if(t===this.intervalQueue[e].id){this.intervalQueue.splice(e,1);break}0===this.intervalQueue.length&&(cancelAnimationFrame(this.intervalTickId),this.intervalTicking=!1)},setTimeout:function(t,e){var n=this,i=this.setInterval((function(){n.clearInterval(i),t()}),e);return i},clearTimeout:function(t){return this.clearInterval(t)}}),$.fn.extend({index:function(t){var e,n=-1;return 0===this.length?n:(e=not(t)?this[0]:t instanceof $&&t.length>0?t[0]:"string"==typeof t?$(t)[0]:void 0,not(e)||e&&e.parentNode&&$.each(e.parentNode.children,(function(t){this===e&&(n=t)})),n)},get:function(t){return void 0===t?this.items():t<0?this[t+this.length]:this[t]},eq:function(t){return!not(t)&&this.length>0?$.extend($(this.get(t)),{_prevObj:this}):this},is:function(t){var e=!1;return 0!==this.length&&(t instanceof $?this.same(t):(":selected"===t?this.each((function(){this.selected&&(e=!0)})):":checked"===t?this.each((function(){this.checked&&(e=!0)})):":visible"===t?this.each((function(){isVisible(this)&&(e=!0)})):":hidden"===t?this.each((function(){var t=getComputedStyle(this);("hidden"===this.getAttribute("type")||this.hidden||"none"===t.display||"hidden"===t.visibility||0===parseInt(t.opacity))&&(e=!0)})):"string"==typeof t&&-1===[":selected"].indexOf(t)?this.each((function(){n.call(this,t)&&(e=!0)})):isArrayLike(t)?this.each((function(){var n=this;$.each(t,(function(){n===this&&(e=!0)}))})):"object"==typeof t&&1===t.nodeType&&this.each((function(){this===t&&(e=!0)})),e))},same:function(t){var e=!0;return t instanceof $||(t=$(t)),this.length===t.length&&(this.each((function(){-1===t.items().indexOf(this)&&(e=!1)})),e)},last:function(){return this.eq(this.length-1)},first:function(){return this.eq(0)},odd:function(){var t=this.filter((function(t,e){return e%2==0}));return $.extend(t,{_prevObj:this})},even:function(){var t=this.filter((function(t,e){return e%2!=0}));return $.extend(t,{_prevObj:this})},filter:function(t){if("string"==typeof t){var e=t;t=function(t){return n.call(t,e)}}return $.extend($.merge($(),[].filter.call(this,t)),{_prevObj:this})},find:function(t){var e,n=[];return t instanceof $?t:(0===this.length?e=this:(this.each((function(){void 0!==this.querySelectorAll&&(n=n.concat([].slice.call(this.querySelectorAll(t))))})),e=$.merge($(),n)),$.extend(e,{_prevObj:this}))},contains:function(t){return this.find(t).length>0},children:function(t){var e,i=[];return t instanceof $?t:(this.each((function(){var t=this;for(e=0;e<t.children.length;e++)1===t.children[e].nodeType&&i.push(t.children[e])})),i=t?i.filter((function(e){return n.call(e,t)})):i,$.extend($.merge($(),i),{_prevObj:this}))},parent:function(t){var e=[];if(0!==this.length)return t instanceof $?t:(this.each((function(){this.parentNode&&-1===e.indexOf(this.parentNode)&&e.push(this.parentNode)})),e=t?e.filter((function(e){return n.call(e,t)})):e,$.extend($.merge($(),e),{_prevObj:this}))},parents:function(t){var e=[];if(0!==this.length)return t instanceof $?t:(this.each((function(){for(var i=this.parentNode;i;)1===i.nodeType&&-1===e.indexOf(i)&&(not(t)||n.call(i,t))&&e.push(i),i=i.parentNode})),$.extend($.merge($(),e),{_prevObj:this}))},siblings:function(t){var e=[];if(0!==this.length)return t instanceof $?t:(this.each((function(){var t=this;t.parentNode&&$.each(t.parentNode.children,(function(){t!==this&&e.push(this)}))})),t&&(e=e.filter((function(e){return n.call(e,t)}))),$.extend($.merge($(),e),{_prevObj:this}))},_siblingAll:function(t,e){var i=[];if(0!==this.length)return e instanceof $?e:(this.each((function(){for(var e=this;e&&(e=e[t]);)i.push(e)})),e&&(i=i.filter((function(t){return n.call(t,e)}))),$.extend($.merge($(),i),{_prevObj:this}))},_sibling:function(t,e){var i=[];if(0!==this.length)return e instanceof $?e:(this.each((function(){var e=this[t];e&&1===e.nodeType&&i.push(e)})),e&&(i=i.filter((function(t){return n.call(t,e)}))),$.extend($.merge($(),i),{_prevObj:this}))},prev:function(t){return this._sibling("previousElementSibling",t)},next:function(t){return this._sibling("nextElementSibling",t)},prevAll:function(t){return this._siblingAll("previousElementSibling",t)},nextAll:function(t){return this._siblingAll("nextElementSibling",t)},closest:function(t){var e=[];if(0!==this.length)return t instanceof $?t:t?(this.each((function(){for(var i=this;i&&i;){if(n.call(i,t))return void e.push(i);i=i.parentElement}})),$.extend($.merge($(),e.reverse()),{_prevObj:this})):this.parent(t)},has:function(t){var e=[];if(0!==this.length)return this.each((function(){$(this).children(t).length>0&&e.push(this)})),$.extend($.merge($(),e),{_prevObj:this})},back:function(t){var e;if(!0===t)for(e=this._prevObj;e&&e._prevObj;)e=e._prevObj;else e=this._prevObj?this._prevObj:this;return e}}),$.extend({script:function(t){if(not(t))return createScript();var e=$(t)[0];e.tagName&&"SCRIPT"===e.tagName?createScript(e):$.each($(e).find("script"),(function(){createScript(this)}))}}),$.fn.extend({script:function(){return this.each((function(){$.script(this)}))}}),$.fn.extend({_prop:function(t,e){return 1===arguments.length?0===this.length?void 0:this[0][t]:(not(e)&&(e=""),this.each((function(){this[t]=e,"innerHTML"===t&&$.script(this)})))},prop:function(t,e){return 1===arguments.length?this._prop(t):this._prop(t,void 0===e?"":e)},val:function(t){return not(t)?0===this.length?void 0:this[0].value:this.each((function(){var e=$(this);void 0!==this.value?this.value=t:e.html(t)}))},html:function(t){var e=[];return 0===arguments.length?this._prop("innerHTML"):(t instanceof $?t.each((function(){e.push($(this).outerHTML())})):e.push(t),this._prop("innerHTML",1===e.length&&not(e[0])?"":e.join("\n")),this)},outerHTML:function(){return this._prop("outerHTML")},text:function(t){return 0===arguments.length?this._prop("textContent"):this._prop("textContent",void 0===t?"":t)},innerText:function(t){return 0===arguments.length?this._prop("innerText"):this._prop("innerText",void 0===t?"":t)},empty:function(){return this.each((function(){void 0!==this.innerHTML&&(this.innerHTML="")}))},clear:function(){return this.empty()}}),$.each=function(t,e){var n=0;if(isArrayLike(t))[].forEach.call(t,(function(t,n){e.apply(t,[n,t])}));else for(var i in t)hasProp(t,i)&&e.apply(t[i],[i,t[i],n++]);return t},$.fn.extend({each:function(t){return $.each(this,t)}});var Data=function(t){this.expando="DATASET:UID:"+t.toUpperCase(),Data.uid++};Data.uid=-1,Data.prototype={cache:function(t){var e=t[this.expando];return e||(e={},acceptData(t)&&(t.nodeType?t[this.expando]=e:Object.defineProperty(t,this.expando,{value:e,configurable:!0}))),e},set:function(t,e,n){var i,o=this.cache(t);if("string"==typeof e)o[camelCase(e)]=n;else for(i in e)hasProp(e,i)&&(o[camelCase(i)]=e[i]);return o},get:function(t,e){return void 0===e?this.cache(t):t[this.expando]&&t[this.expando][camelCase(e)]},access:function(t,e,n){return void 0===e||e&&"string"==typeof e&&void 0===n?this.get(t,e):(this.set(t,e,n),void 0!==n?n:e)},remove:function(t,e){var n,i=t[this.expando];if(void 0!==i){if(void 0!==e){n=(e=Array.isArray(e)?e.map(camelCase):(e=camelCase(e))in i?[e]:e.match(/[^\x20\t\r\n\f]+/g)||[]).length;for(;n--;)delete i[e[n]]}return(void 0===e||isEmptyObject(i))&&(t.nodeType?t[this.expando]=void 0:delete t[this.expando]),!0}},hasData:function(t){var e=t[this.expando];return void 0!==e&&!isEmptyObject(e)}};var i=new Data("m4q");$.extend({hasData:function(t){return i.hasData(t)},data:function(t,e,n){return i.access(t,e,n)},removeData:function(t,e){return i.remove(t,e)},dataSet:function(t){if(not(t))return i;if(["INTERNAL","M4Q"].indexOf(t.toUpperCase())>-1)throw Error("You can not use reserved name for your dataset");return new Data(t)}}),$.fn.extend({data:function(t,e){var n,o,r,a,s,c;if(0!==this.length){if(o=this[0],0===arguments.length){if(this.length&&(r=i.get(o),1===o.nodeType))for(c=(a=o.attributes).length;c--;)a[c]&&0===(s=a[c].name).indexOf("data-")&&dataAttr(o,s=camelCase(s.slice(5)),r[s]);return r}return 1===arguments.length?(void 0===(n=i.get(o,t))&&1===o.nodeType&&o.hasAttribute("data-"+t)&&(n=o.getAttribute("data-"+t)),n):this.each((function(){i.set(this,t,e)}))}},removeData:function(t){return this.each((function(){i.remove(this,t)}))},origin:function(t,e,n){if(0===this.length)return this;if(not(t)&&not(e))return $.data(this[0]);if(not(e)){var i=$.data(this[0],"origin-"+t);return not(i)?n:i}return this.data("origin-"+t,e),this}}),$.extend({device:/android|webos|iphone|ipad|ipod|blackberry|iemobile|opera mini/i.test(navigator.userAgent.toLowerCase()),localhost:isLocalhost(),isLocalhost:isLocalhost,touchable:function isTouch(){return"ontouchstart"in window||navigator.maxTouchPoints>0||navigator.msMaxTouchPoints>0}(),uniqueId:function(t){var e=(new Date).getTime();return not(t)&&(t="m4q"),(""!==t?t+"-":"")+"xxxx-xxxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,(function(t){var n=(e+16*Math.random())%16|0;return e=Math.floor(e/16),("x"===t?n:3&n|8).toString(16)}))},toArray:function(t){var e,n=[];for(e=0;e<t.length;e++)n.push(t[e]);return n},import:function(t){var e=[];return this.each(t,(function(){e.push(this)})),this.merge($(),e)},merge:function(t,e){for(var n=+e.length,i=0,o=t.length;i<n;i++)t[o++]=e[i];return t.length=o,t},type:function(t){return Object.prototype.toString.call(t).replace(/^\[object (.+)]$/,"$1").toLowerCase()},sleep:function(t){(new Date).getTime()},isSelector:function(t){if("string"!=typeof t)return!1;try{document.querySelector(t)}catch(t){return!1}return!0},remove:function(t){return $(t).remove()},camelCase:camelCase,dashedName:function dashedName(t){return t.replace(/([A-Z])/g,(function(t){return"-"+t.toLowerCase()}))},isPlainObject:isPlainObject,isEmptyObject:isEmptyObject,isArrayLike:isArrayLike,acceptData:acceptData,not:not,parseUnit:parseUnit,getUnit:getUnit,unit:parseUnit,isVisible:isVisible,isHidden:function isHidden(t){var e=getComputedStyle(t);return!isVisible(t)||0==+e.opacity||t.hidden||"hidden"===e.visibility},matches:function(t,e){return n.call(t,e)},random:function(t,e){return 1===arguments.length&&isArrayLike(t)?t[Math.floor(Math.random()*t.length)]:Math.floor(Math.random()*(e-t+1)+t)},strip:function strip(t,e){return"string"!=typeof t?void 0:t.replace(e,"")},normName:normName,hasProp:hasProp,serializeToArray:function(t){var e=$(t)[0];if(e&&"FORM"===e.nodeName){var n,i,o=[];for(n=e.elements.length-1;n>=0;n-=1)if(""!==e.elements[n].name)switch(e.elements[n].nodeName){case"INPUT":switch(e.elements[n].type){case"checkbox":case"radio":e.elements[n].checked&&o.push(e.elements[n].name+"="+encodeURIComponent(e.elements[n].value));break;case"file":break;default:o.push(e.elements[n].name+"="+encodeURIComponent(e.elements[n].value))}break;case"TEXTAREA":o.push(e.elements[n].name+"="+encodeURIComponent(e.elements[n].value));break;case"SELECT":switch(e.elements[n].type){case"select-one":o.push(e.elements[n].name+"="+encodeURIComponent(e.elements[n].value));break;case"select-multiple":for(i=e.elements[n].options.length-1;i>=0;i-=1)e.elements[n].options[i].selected&&o.push(e.elements[n].name+"="+encodeURIComponent(e.elements[n].options[i].value))}break;case"BUTTON":switch(e.elements[n].type){case"reset":case"submit":case"button":o.push(e.elements[n].name+"="+encodeURIComponent(e.elements[n].value))}}return o}console.warn("Element is not a HTMLFromElement")},serialize:function(t){return $.serializeToArray(t).join("&")}}),$.fn.extend({items:function(){return $.toArray(this)}}),function(){if("function"==typeof window.CustomEvent)return!1;function CustomEvent(t,e){e=e||{bubbles:!1,cancelable:!1,detail:null};var n=document.createEvent("CustomEvent");return n.initCustomEvent(t,e.bubbles,e.cancelable,e.detail),n}CustomEvent.prototype=window.Event.prototype,window.CustomEvent=CustomEvent}();var o=Event.prototype.stopPropagation,r=Event.prototype.preventDefault;Event.prototype.stopPropagation=function(){this.isPropagationStopped=!0,o.apply(this,arguments)},Event.prototype.preventDefault=function(){this.isPreventedDefault=!0,r.apply(this,arguments)},Event.prototype.stop=function(t){return t?this.stopImmediatePropagation():this.stopPropagation()},$.extend({events:[],eventHooks:{},eventUID:-1,setEventHandler:function(t){var e,n,i,o=-1;if(this.events.length>0)for(e=0;e<this.events.length;e++)if(null===this.events[e].handler){o=e;break}return n={element:t.el,event:t.event,handler:t.handler,selector:t.selector,ns:t.ns,id:t.id,options:t.options},-1===o?(this.events.push(n),i=this.events.length-1):(this.events[o]=n,i=o),i},getEventHandler:function(t){if(void 0!==this.events[t]&&null!==this.events[t])return this.events[t]=null,this.events[t].handler},off:function(){return $.each(this.events,(function(){this.element.removeEventListener(this.event,this.handler,!0)})),this.events=[],this},getEvents:function(){return this.events},getEventHooks:function(){return this.eventHooks},addEventHook:function(t,e,n){return not(n)&&(n="before"),$.each(str2arr(t),(function(){this.eventHooks[camelCase(n+"-"+this)]=e})),this},removeEventHook:function(t,e){return not(e)&&(e="before"),$.each(str2arr(t),(function(){delete this.eventHooks[camelCase(e+"-"+this)]})),this},removeEventHooks:function(t){var e=this;return not(t)?this.eventHooks={}:$.each(str2arr(t),(function(){delete e.eventHooks[camelCase("before-"+this)],delete e.eventHooks[camelCase("after-"+this)]})),this}}),$.fn.extend({on:function(t,e,i,o){if(0!==this.length)return"function"==typeof e&&(o=i,i=e,e=void 0),isPlainObject(o)||(o={}),this.each((function(){var r=this;$.each(str2arr(t),(function(){var t,a,s,c=this.split("."),u=normName(c[0]),l=o.ns?o.ns:c[1];$.eventUID++,t=function(t){var s=t.target,c=$.eventHooks[camelCase("before-"+u)],f=$.eventHooks[camelCase("after-"+u)];if("function"==typeof c&&c.call(s,t),e)for(;s&&s!==r;){if(n.call(s,e)&&(i.call(s,t),t.isPropagationStopped)){t.stopImmediatePropagation();break}s=s.parentNode}else i.call(r,t);"function"==typeof f&&f.call(s,t),o.once&&(a=+$(r).origin("event-"+t.type+(e?":"+e:"")+(l?":"+l:"")),isNaN(a)||$.events.splice(a,1))},Object.defineProperty(t,"name",{value:i.name&&""!==i.name?i.name:"func_event_"+u+"_"+$.eventUID}),s=u+(e?":"+e:"")+(l?":"+l:""),r.addEventListener(u,t,!isEmptyObject(o)&&o),a=$.setEventHandler({el:r,event:u,handler:t,selector:e,ns:l,id:$.eventUID,options:!isEmptyObject(o)&&o}),$(r).origin("event-"+s,a)}))}))},one:function(t,e,n,i){return isPlainObject(i)||(i={}),i.once=!0,this.on.apply(this,[t,e,n,i])},off:function(t,e,n){return isPlainObject(e)&&(n=e,e=null),isPlainObject(n)||(n={}),not(t)||"all"===t.toLowerCase()?this.each((function(){var t=this;$.each($.events,(function(){var e=this;e.element===t&&(t.removeEventListener(e.event,e.handler,e.options),e.handler=null,$(t).origin("event-"+name+(e.selector?":"+e.selector:"")+(e.ns?":"+e.ns:""),null))}))})):this.each((function(){var i=this;$.each(str2arr(t),(function(){var t,o,r=this.split("."),a=normName(r[0]),s=n.ns?n.ns:r[1];t="event-"+a+(e?":"+e:"")+(s?":"+s:""),void 0!==(o=$(i).origin(t))&&$.events[o].handler&&(i.removeEventListener(a,$.events[o].handler,$.events[o].options),$.events[o].handler=null),$(i).origin(t,null)}))}))},trigger:function(t,e){return this.fire(t,e)},fire:function(t,e){var n,i;if(0!==this.length)return n=normName(t),["focus","blur"].indexOf(n)>-1?(this[0][n](),this):("undefined"!=typeof CustomEvent?i=new CustomEvent(n,{bubbles:!0,cancelable:!0,detail:e}):((i=document.createEvent("Events")).detail=e,i.initEvent(n,!0,!0)),this.each((function(){this.dispatchEvent(i)})))}}),"blur focus resize scroll click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup contextmenu touchstart touchend touchmove touchcancel".split(" ").forEach((function(t){$.fn[t]=function(e,n,i){return arguments.length>0?this.on(t,e,n,i):this.fire(t)}})),$.fn.extend({hover:function(t,e){return this.mouseenter(t).mouseleave(e||t)}}),$.ready=function(t,e){document.addEventListener("DOMContentLoaded",t,e||!1)},$.load=function(t){return $(window).on("load",t)},$.unload=function(t){return $(window).on("unload",t)},$.fn.extend({unload:function(t){return 0===this.length||this[0].self!==window?void 0:$.unload(t)}}),$.beforeunload=function(t){return"string"==typeof t?$(window).on("beforeunload",(function(e){return e.returnValue=t,t})):$(window).on("beforeunload",t)},$.fn.extend({beforeunload:function(t){return 0===this.length||this[0].self!==window?void 0:$.beforeunload(t)}}),$.fn.extend({ready:function(t){if(this.length&&this[0]===document&&"function"==typeof t)return $.ready(t)}}),$.ajax=function(t){return new Promise((function(e,n){var i,o,r,a=new XMLHttpRequest,s=(t.method||"GET").toUpperCase(),c=[],u=!!not(t.async)||t.async,l=t.url,exec=function(t,e){"function"==typeof t&&t.apply(null,e)},isGet=function(t){return-1!==["GET","JSON"].indexOf(t)};if(t.data instanceof HTMLFormElement){var f=t.data.getAttribute("action"),h=t.data.getAttribute("method");not(l)&&f&&""!==f.trim()&&(l=f),h&&""!==h.trim()&&(s=h.toUpperCase())}if(t.timeout&&(a.timeout=t.timeout),t.withCredentials&&(a.withCredentials=t.withCredentials),t.data instanceof HTMLFormElement)i=$.serialize(t.data);else if(t.data instanceof HTMLElement&&t.data.getAttribute("type")&&"file"===t.data.getAttribute("type").toLowerCase()){var p=t.data.getAttribute("name");i=new FormData;for(var d=0;d<t.data.files.length;d++)i.append(p,t.data.files[d])}else isPlainObject(t.data)?(o=t.data,r=[],$.each(o,(function(t,e){var n=function isSimple(t){return"string"==typeof t||"boolean"==typeof t||"number"==typeof t}(e)?e:JSON.stringify(e);r.push(t+"="+n)})),i=r.join("&")):t.data instanceof FormData||"string"==typeof t.data?i=t.data:(i=new FormData).append("_data",JSON.stringify(t.data));isGet(s)&&(l+="string"==typeof i?"?"+i:isEmptyObject(i)?"":"?"+JSON.stringify(i)),a.open(s,l,u,t.user,t.password),t.headers&&$.each(t.headers,(function(t,e){a.setRequestHeader(t,e),c.push(t)})),isGet(s)||-1===c.indexOf("Content-type")&&!1!==t.contentType&&a.setRequestHeader("Content-type","application/x-www-form-urlencoded"),a.send(i),a.addEventListener("load",(function(i){if(4===a.readyState&&a.status<300){var o=t.returnValue&&"xhr"===t.returnValue?a:a.response;if(t.parseJson)try{o=JSON.parse(o)}catch(t){o={}}exec(e,[o]),exec(t.onSuccess,[i,a])}else exec(n,[a]),exec(t.onFail,[i,a]);exec(t.onLoad,[i,a])})),$.each(["readystatechange","error","timeout","progress","loadstart","loadend","abort"],(function(){var e=camelCase("on-"+("readystatechange"===this?"state":this));a.addEventListener(e,(function(n){exec(t[e],[n,a])}))}))}))},["get","post","put","patch","delete","json"].forEach((function(t){$[t]=function(e,n,i){var o=t.toUpperCase(),r={method:"JSON"===o?"GET":o,url:e,data:n,parseJson:"JSON"===o};return $.ajax($.extend({},r,i))}})),$.fn.extend({load:function(t,e,n){var i=this;return this.length&&this[0].self===window?$.load(t):$.get(t,e,n).then((function(t){i.each((function(){this.innerHTML=t}))}))}}),$.fn.extend({style:function(t,e){var n;function _getStyle(t,e,n){return["scrollLeft","scrollTop"].indexOf(e)>-1?$(t)[e]():getComputedStyle(t,n)[e]}if("string"!=typeof t||0!==this.length){if(0===this.length)return this;if(n=this[0],not(t)||"all"===t)return getComputedStyle(n,e);var i={},o=t.split(", ").map((function(t){return(""+t).trim()}));return 1===o.length?_getStyle(n,o[0],e):($.each(o,(function(){i[this]=_getStyle(n,this,e)})),i)}},removeStyleProperty:function(t){if(not(t)||0===this.length)return this;var e=t.split(", ").map((function(t){return(""+t).trim()}));return this.each((function(){var t=this;$.each(e,(function(){t.style.removeProperty(this)}))}))},css:function(t,e){return"string"==typeof(t=t||"all")&&not(e)?this.style(t):this.each((function(){var n=this;"object"==typeof t?$.each(t,(function(t,e){setStyleProp(n,t,e)})):"string"==typeof t&&setStyleProp(n,t,e)}))},scrollTop:function(t){return not(t)?0===this.length?void 0:this[0]===window?pageYOffset:this[0].scrollTop:this.each((function(){this.scrollTop=t}))},scrollLeft:function(t){return not(t)?0===this.length?void 0:this[0]===window?pageXOffset:this[0].scrollLeft:this.each((function(){this.scrollLeft=t}))}}),$.fn.extend({addClass:function(){},removeClass:function(){},toggleClass:function(){},containsClass:function(t){return this.hasClass(t)},hasClass:function(t){var e=!1,n=t.split(" ").filter((function(t){return""!==(""+t).trim()}));return!not(t)&&(this.each((function(){var t=this;$.each(n,(function(){!e&&t.classList&&t.classList.contains(this)&&(e=!0)}))})),e)},clearClasses:function(){return this.each((function(){this.className=""}))},cls:function(t){return 0===this.length?void 0:t?this[0].className.split(" "):this[0].className},removeClassBy:function(t){return this.each((function(){var e=$(this),n=e.cls(!0);$.each(n,(function(){this.indexOf(t)>-1&&e.removeClass(this)}))}))},classNames:function(){var t=Array.prototype.slice.call(arguments,0),e=[];return $.each(t,(function(t,n){"string"==typeof n?e.push(n):isPlainObject(n)&&$.each(n,(function(t,n){n&&e.push(t)}))})),this.each((function(){this.className+=" "+e.join(" ")}))}}),["add","remove","toggle"].forEach((function(t){$.fn[t+"Class"]=function(e){var n=e?Array.isArray(e)?e:e.split(" ").filter((function(t){return!!t})):[];return n.length?this.each((function(){var e=this;void 0!==e.classList?$.each(n,(function(n,i){e.classList[t](i)})):e.className+=n.join(" ")})):this}})),$.parseHTML=function(t){var e,n,i,o,r=[];if("string"!=typeof t)return[];if(t=t.trim(),(e=(i=document.implementation.createHTMLDocument("")).createElement("base")).href=document.location.href,i.head.appendChild(e),o=i.body,n=/^<([a-z][^\/\0>:\x20\t\r\n\f]*)[\x20\t\r\n\f]*\/?>(?:<\/\1>|)$/i.exec(t))r.push(document.createElement(n[1]));else{o.innerHTML=t;for(var a=0;a<o.childNodes.length;a++)r.push(o.childNodes[a])}return r},$.fn.extend({_size:function(t,e){if(0!==this.length){if(not(e)){var n=this[0];if("height"===t)return n===window?window.innerHeight:n===document?n.body.clientHeight:parseInt(getComputedStyle(n).height);if("width"===t)return n===window?window.innerWidth:n===document?n.body.clientWidth:parseInt(getComputedStyle(n).width)}return this.each((function(){var n=this;n!==window&&n!==document&&(n.style[t]=isNaN(e)?e:e+"px")}))}},height:function(t){return this._size("height",t)},width:function(t){return this._size("width",t)},_sizeOut:function(t,e){var n,i,o,r;if(0!==this.length)return not(e)||"boolean"==typeof e?(i=(n=this[0])["width"===t?"offsetWidth":"offsetHeight"],o=getComputedStyle(n),r=i+parseInt(o["width"===t?"margin-left":"margin-top"])+parseInt(o["width"===t?"margin-right":"margin-bottom"]),!0===e?r:i):this.each((function(){var n=this;if(n!==window&&n!==document){var i,o=getComputedStyle(n),r="width"===t?parseInt(o["border-left-width"])+parseInt(o["border-right-width"]):parseInt(o["border-top-width"])+parseInt(o["border-bottom-width"]),a="width"===t?parseInt(o["padding-left"])+parseInt(o["padding-right"]):parseInt(o["padding-top"])+parseInt(o["padding-bottom"]);i=$(this)[t](e)[t]()-r-a,n.style[t]=i+"px"}}))},outerWidth:function(t){return this._sizeOut("width",t)},outerHeight:function(t){return this._sizeOut("height",t)},padding:function(t){if(0!==this.length){var e=getComputedStyle(this[0],t);return{top:parseInt(e["padding-top"]),right:parseInt(e["padding-right"]),bottom:parseInt(e["padding-bottom"]),left:parseInt(e["padding-left"])}}},margin:function(t){if(0!==this.length){var e=getComputedStyle(this[0],t);return{top:parseInt(e["margin-top"]),right:parseInt(e["margin-right"]),bottom:parseInt(e["margin-bottom"]),left:parseInt(e["margin-left"])}}},border:function(t){if(0!==this.length){var e=getComputedStyle(this[0],t);return{top:parseInt(e["border-top-width"]),right:parseInt(e["border-right-width"]),bottom:parseInt(e["border-bottom-width"]),left:parseInt(e["border-left-width"])}}}}),$.fn.extend({offset:function(t){var e;if(not(t)){if(0===this.length)return;return{top:(e=this[0].getBoundingClientRect()).top+pageYOffset,left:e.left+pageXOffset}}return this.each((function(){var e=$(this),n=t.top,i=t.left,o=getComputedStyle(this).position,r=e.offset();"static"===o&&e.css("position","relative"),-1===["absolute","fixed"].indexOf(o)&&(n-=r.top,i-=r.left),e.css({top:n,left:i})}))},position:function(t){var e,n,i=0,o=0;if((not(t)||"boolean"!=typeof t)&&(t=!1),0!==this.length)return e=this[0],n=getComputedStyle(e),t&&(i=parseInt(n["margin-left"]),o=parseInt(n["margin-top"])),{left:e.offsetLeft-i,top:e.offsetTop-o}},left:function(t,e){if(0!==this.length)return not(t)?this.position(e).left:"boolean"==typeof t?(e=t,this.position(e).left):this.each((function(){$(this).css({left:t})}))},top:function(t,e){if(0!==this.length)return not(t)?this.position(e).top:"boolean"==typeof t?(e=t,this.position(e).top):this.each((function(){$(this).css({top:t})}))},coord:function(){return 0===this.length?void 0:this[0].getBoundingClientRect()},pos:function(){if(0!==this.length)return{top:parseInt($(this[0]).style("top")),left:parseInt($(this[0]).style("left"))}}}),$.fn.extend({attr:function(t,e){var n={};if(0!==this.length||0!==arguments.length)return this.length&&0===arguments.length?($.each(this[0].attributes,(function(){n[this.nodeName]=this.nodeValue})),n):1===arguments.length&&"string"==typeof t?this.length&&1===this[0].nodeType&&this[0].hasAttribute(t)?this[0].getAttribute(t):void 0:this.each((function(){var n=this;isPlainObject(t)?$.each(t,(function(t,e){n.setAttribute(t,e)})):n.setAttribute(t,e)}))},removeAttr:function(t){var e;return not(t)?this.each((function(){var t=this;$.each(this.attributes,(function(){t.removeAttribute(this)}))})):(e="string"==typeof t?t.split(",").map((function(t){return t.trim()})):t,this.each((function(){var t=this;$.each(e,(function(){t.hasAttribute(this)&&t.removeAttribute(this)}))})))},toggleAttr:function(t,e){return this.each((function(){not(e)?this.removeAttribute(t):this.setAttribute(t,e)}))},id:function(t){return this.length?$(this[0]).attr("id",t):void 0}}),$.extend({meta:function(t){return not(t)?$("meta"):$("meta[name='$name']".replace("$name",t))},metaBy:function(t){return not(t)?$("meta"):$("meta[$name]".replace("$name",t))},doctype:function(){return $("doctype")},html:function(){return $("html")},head:function(){return $("html").find("head")},body:function(){return $("body")},document:function(){return $(document)},window:function(){return $(window)},charset:function(t){var e=$("meta[charset]");return t&&e.attr("charset",t),e.attr("charset")}}),$.extend({proxy:function(t,e){return"function"!=typeof t?void 0:t.bind(e)},bind:function(t,e){return this.proxy(t,e)}}),[Element.prototype,Document.prototype,DocumentFragment.prototype].forEach((function(t){["append","prepend"].forEach((function(e){hasProp(t,e)||Object.defineProperty(t,e,{configurable:!0,enumerable:!0,writable:!0,value:function(){var t=Array.prototype.slice.call(arguments),n=document.createDocumentFragment();t.forEach((function(t){var e=t instanceof Node;n.appendChild(e?t:document.createTextNode(String(t)))})),"prepend"===e?this.insertBefore(n,this.firstChild):this.appendChild(n)}})}))}));var normalizeElements=function(t){var e;return"string"==typeof t?e=$.isSelector(t)?$(t):$.parseHTML(t):t instanceof HTMLElement?e=[t]:isArrayLike(t)&&(e=t),e};$.fn.extend({appendText:function(t){return this.each((function(e,n){n.innerHTML+=t}))},prependText:function(t){return this.each((function(e,n){n.innerHTML=t+n.innerHTML}))},append:function(t){var e=normalizeElements(t);return this.each((function(t,n){$.each(e,(function(){if(n!==this){var e=0===t?this:this.cloneNode(!0);$.script(e),e.tagName&&"SCRIPT"!==e.tagName&&n.append(e)}}))}))},appendTo:function(t){var e=normalizeElements(t);return this.each((function(){var t=this;$.each(e,(function(e,n){t!==this&&n.append(0===e?t:t.cloneNode(!0))}))}))},prepend:function(t){var e=normalizeElements(t);return this.each((function(t,n){$.each(e,(function(){if(n!==this){var e=0===t?this:this.cloneNode(!0);$.script(e),e.tagName&&"SCRIPT"!==e.tagName&&n.prepend(e)}}))}))},prependTo:function(t){var e=normalizeElements(t);return this.each((function(){var t=this;$.each(e,(function(e,n){t!==this&&$(n).prepend(0===e?t:t.cloneNode(!0))}))}))},insertBefore:function(t){var e=normalizeElements(t);return this.each((function(){var t=this;$.each(e,(function(e){if(t!==this){var n=this.parentNode;n&&n.insertBefore(0===e?t:t.cloneNode(!0),this)}}))}))},insertAfter:function(t){var e=normalizeElements(t);return this.each((function(){var t=this;$.each(e,(function(e,n){if(t!==this){var i=this.parentNode;i&&i.insertBefore(0===e?t:t.cloneNode(!0),n.nextSibling)}}))}))},after:function(t){return this.each((function(){"string"==typeof t?this.insertAdjacentHTML("afterend",t):$(t).insertAfter(this)}))},before:function(t){return this.each((function(){"string"==typeof t?this.insertAdjacentHTML("beforebegin",t):$(t).insertBefore(this)}))},clone:function(t,e){var n=[];return not(t)&&(t=!1),not(e)&&(e=!1),this.each((function(){var i,o=this.cloneNode(t),r=$(o);e&&$.hasData(this)&&(i=$(this).data(),$.each(i,(function(t,e){r.data(t,e)}))),n.push(o)})),$.merge($(),n)},import:function(t){var e=[];return not(t)&&(t=!1),this.each((function(){e.push(document.importNode(this,t))})),$.merge($(),e)},adopt:function(){var t=[];return this.each((function(){t.push(document.adoptNode(this))})),$.merge($(),t)},remove:function(t){var e,i,o=0,r=[];if(0!==this.length){for(i=t?this.filter((function(e){return n.call(e,t)})):this.items();null!=(e=i[o]);o++)e.parentNode&&(r.push(e.parentNode.removeChild(e)),$.removeData(e));return $.merge($(),r)}},wrap:function(t){if(0!==this.length){var e=$(normalizeElements(t));if(e.length){var n=[];return this.each((function(){var t,i;for((i=e.clone(!0,!0)).insertBefore(this),t=i;t.children().length;)t=t.children().eq(0);t.append(this),n.push(i)})),$(n)}}},wrapAll:function(t){var e,n,i;if(0!==this.length&&(e=$(normalizeElements(t))).length){for((n=e.clone(!0,!0)).insertBefore(this[0]),i=n;i.children().length;)i=i.children().eq(0);return this.each((function(){i.append(this)})),n}},wrapInner:function(t){if(0!==this.length){var e=$(normalizeElements(t));if(e.length){var n=[];return this.each((function(){var t=$(this),i=t.html(),o=e.clone(!0,!0);t.html(o.html(i)),n.push(o)})),$(n)}}}}),$.extend({animation:{duration:1e3,ease:"linear",elements:{}}}),"object"==typeof window.setupAnimation&&$.each(window.setupAnimation,(function(t,e){void 0===$.animation[t]||not(e)||($.animation[t]=e)}));var a=["translateX","translateY","translateZ","rotate","rotateX","rotateY","rotateZ","scale","scaleX","scaleY","scaleZ","skew","skewX","skewY"],s=["opacity","zIndex"],c=["opacity","volume"],u=["scrollLeft","scrollTop"],l=["opacity","volume"];function _validElement(t){return t instanceof HTMLElement||t instanceof SVGElement}function _applyStyles(t,e,n){$.each(e,(function(e,i){!function _setStyle(t,e,n,i,o){not(o)&&(o=!1),e=camelCase(e),o&&(n=parseInt(n)),_validElement(t)?void 0!==t[e]?t[e]=n:t.style[e]="transform"===e||e.toLowerCase().indexOf("color")>-1?n:n+i:t[e]=n}(t,e,i[0]+i[2]*n,i[3],i[4])}))}function _getElementTransforms(t){if(!_validElement(t))return{};for(var e,n=t.style.transform||"",i=/(\w+)\(([^)]*)\)/g,o={};e=i.exec(n);)o[e[1]]=e[2];return o}function _getColorArrayFromHex(t){return/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(t||"#000000").slice(1).map((function(t){return parseInt(t,16)}))}function _expandColorValue(t){return"#"===t[0]&&4===t.length?"#"+t.replace(/^#?([a-f\d])([a-f\d])([a-f\d])$/i,(function(t,e,n,i){return e+e+n+n+i+i})):"#"===t[0]?t:"#"+t}function applyProps(t,e,n){_applyStyles(t,e.props,n),function _applyTransform(t,e,n){var i=[],o=_getElementTransforms(t);$.each(e,(function(t,e){var o=e[0],r=e[1],a=e[2],s=e[3];((t=""+t).indexOf("rotate")>-1||t.indexOf("skew")>-1)&&""===s&&(s="deg"),t.indexOf("scale")>-1&&(s=""),t.indexOf("translate")>-1&&""===s&&(s="px"),"turn"===s?i.push(t+"("+r*n+s+")"):i.push(t+"("+(o+a*n)+s+")")})),$.each(o,(function(t,n){void 0===e[t]&&i.push(t+"("+n+")")})),t.style.transform=i.join(" ")}(t,e.transform,n),function _applyColors(t,e,n){$.each(e,(function(e,i){var o,r,a=[0,0,0];for(o=0;o<3;o++)a[o]=Math.floor(i[0][o]+i[2][o]*n);r="rgb("+a.join(",")+")",t.style[e]=r}))}(t,e.color,n)}function createAnimationMap(t,e,n){var i,o,r,f,h,p,d={props:{},transform:{},color:{}},m=_getElementTransforms(t);return not(n)&&(n="normal"),$.each(e,(function(e,v){var y=a.indexOf(""+e)>-1,$=s.indexOf(""+e)>-1,g=(""+e).toLowerCase().indexOf("color")>-1;if(Array.isArray(v)&&1===v.length&&(v=v[0]),Array.isArray(v)?(o=g?_getColorArrayFromHex(_expandColorValue(v[0])):parseUnit(v[0]),r=g?_getColorArrayFromHex(_expandColorValue(v[1])):parseUnit(v[1])):(o=y?m[e]||0:g?function _getColorArrayFromElement(t,e){return getComputedStyle(t)[e].replace(/[^\d.,]/g,"").split(",").map((function(t){return parseInt(t)}))}(t,e):function _getStyle(t,e,n){return void 0!==t[e]?u.indexOf(e)>-1?"scrollLeft"===e?t===window?pageXOffset:t.scrollLeft:t===window?pageYOffset:t.scrollTop:t[e]||0:t.style[e]||getComputedStyle(t,n)[e]}(t,e),o=g?o:parseUnit(o),r=g?_getColorArrayFromHex(v):parseUnit(function _getRelativeValue(t,e){var n=/^(\*=|\+=|-=)/.exec(t);if(!n)return t;var i=getUnit(t)||0,o=parseFloat(e),r=parseFloat(t.replace(n[0],""));switch(n[0][0]){case"+":return o+r+i;case"-":return o-r+i;case"*":return o*r+i;case"/":return o/r+i}}(v,Array.isArray(o)?o[0]:o))),l.indexOf(""+e)>-1&&o[0]===r[0]&&(o[0]=r[0]>0?0:1),"reverse"===n&&(p=o,o=r,r=p),h=t instanceof HTMLElement&&""===r[1]&&!$&&!y?"px":r[1],g)for(f=[0,0,0],i=0;i<3;i++)f[i]=r[i]-o[i];else f=r[0]-o[0];y?d.transform[e]=[o[0],r[0],f,h]:g?d.color[e]=[o,r,f,h]:d.props[e]=[o[0],r[0],f,h,-1===c.indexOf(""+e)]})),d}function minMax(t,e,n){return Math.min(Math.max(t,e),n)}var f={linear:function(){return function(t){return t}}};f.default=f.linear;var h={Sine:function(){return function(t){return 1-Math.cos(t*Math.PI/2)}},Circ:function(){return function(t){return 1-Math.sqrt(1-t*t)}},Back:function(){return function(t){return t*t*(3*t-2)}},Bounce:function(){return function(t){for(var e,n=4;t<((e=Math.pow(2,--n))-1)/11;);return 1/Math.pow(4,3-n)-7.5625*Math.pow((3*e-2)/22-t,2)}},Elastic:function(t,e){not(t)&&(t=1),not(e)&&(e=.5);var n=minMax(t,1,10),i=minMax(e,.1,2);return function(t){return 0===t||1===t?t:-n*Math.pow(2,10*(t-1))*Math.sin((t-1-i/(2*Math.PI)*Math.asin(1/n))*(2*Math.PI)/i)}}};["Quad","Cubic","Quart","Quint","Expo"].forEach((function(t,e){h[t]=function(){return function(t){return Math.pow(t,e+2)}}})),Object.keys(h).forEach((function(t){var e=h[t];f["easeIn"+t]=e,f["easeOut"+t]=function(t,n){return function(i){return 1-e(t,n)(1-i)}},f["easeInOut"+t]=function(t,n){return function(i){return i<.5?e(t,n)(2*i)/2:1-e(t,n)(-2*i+2)/2}}}));var p={id:null,el:null,draw:{},dur:$.animation.duration,ease:$.animation.ease,loop:0,pause:0,dir:"normal",defer:0,onStart:function(){},onStop:function(){},onStopAll:function(){},onPause:function(){},onPauseAll:function(){},onResume:function(){},onResumeAll:function(){},onFrame:function(){},onDone:function(){}};function animate(t){return new Promise((function(e){var n,i=this,o=$.assign({},p,{dur:$.animation.duration,ease:$.animation.ease},t),r=o.id,a=o.el,s=o.draw,c=o.dur,u=o.ease,l=o.loop,h=o.onStart,d=o.onFrame,m=o.onDone,v=o.pause,y=o.dir,g=o.defer,b={},w="linear",x=[],C=f.linear,A="alternate"===y?"normal":y,T=!1,E=r||+performance.now()*Math.pow(10,14);if(not(a))throw new Error("Unknown element!");if("string"==typeof a&&(a=document.querySelector(a)),"function"!=typeof s&&"object"!=typeof s)throw new Error("Unknown draw object. Must be a function or object!");0===c&&(c=1),"alternate"===y&&"number"==typeof l&&(l*=2),"string"==typeof u?(n=/\(([^)]+)\)/.exec(u),w=u.split("(")[0],x=n?n[1].split(",").map((function(t){return parseFloat(t)})):[],C=f[w]||f.linear):C="function"==typeof u?u:f.linear,$.animation.elements[E]={element:a,id:null,stop:0,pause:0,loop:0,t:-1,started:0,paused:0};var play=function(){"object"==typeof s&&(b=createAnimationMap(a,s,A)),"function"==typeof h&&h.apply(a),$.animation.elements[E].loop+=1,$.animation.elements[E].started=performance.now(),$.animation.elements[E].duration=c,$.animation.elements[E].id=requestAnimationFrame(animate)},done=function(){cancelAnimationFrame($.animation.elements[E].id),delete $.animation.elements[r],"function"==typeof m&&m.apply(a),e(i)},animate=function(t){var e,n,i=$.animation.elements[E].stop,o=$.animation.elements[E].pause,r=$.animation.elements[E].started;if($.animation.elements[E].paused&&(r=t-$.animation.elements[E].t*c,$.animation.elements[E].started=r),(n=((t-r)/c).toFixed(4))>1&&(n=1),n<0&&(n=0),e=C.apply(null,x)(n),$.animation.elements[E].t=n,$.animation.elements[E].p=e,o)$.animation.elements[E].id=requestAnimationFrame(animate);else{if(i>0)return 2===i&&("function"==typeof s?s.bind(a)(1,1):applyProps(a,b,1)),void done();"function"==typeof s?s.bind(a)(n,e):applyProps(a,b,e),"function"==typeof d&&d.apply(a,[n,e]),n<1&&($.animation.elements[E].id=requestAnimationFrame(animate)),1===parseInt(n)&&(l?("alternate"===y&&(A="normal"===A?"reverse":"normal"),"boolean"==typeof l||l>$.animation.elements[E].loop?setTimeout((function(){play()}),v):done()):"alternate"!==y||T?done():(A="normal"===A?"reverse":"normal",T=!0,play()))}};g>0?setTimeout((function(){play()}),g):play()}))}function stopAnimation(t,e){var n=$.animation.elements[t];void 0!==n&&(not(e)&&(e=!0),n.stop=!0===e?2:1,"function"==typeof n.onStop&&n.onStop.apply(n.element))}function pauseAnimation(t){var e=$.animation.elements[t];void 0!==e&&(e.pause=1,e.paused=performance.now(),"function"==typeof e.onPause&&e.onPause.apply(e.element))}function resumeAnimation(t){var e=$.animation.elements[t];void 0!==e&&(e.pause=0,e.paused=0,"function"==typeof e.onResume&&e.onResume.apply(e.element))}var d={loop:!1,onChainItem:null,onChainItemComplete:null,onChainComplete:null};$.easing={},$.extend($.easing,f),$.extend({animate:function(t){var e,n,i,o,r;return arguments.length>1?(e=$(arguments[0])[0],n=arguments[1],i=arguments[2]||$.animation.duration,o=arguments[3]||$.animation.ease,r=arguments[4],"function"==typeof i&&(r=i,o=$.animation.ease,i=$.animation.duration),"function"==typeof o&&(r=o,o=$.animation.ease),animate({el:e,draw:n,dur:i,ease:o,onDone:r})):animate(t)},chain:function chain(t,e){var n=$.extend({},d,e);if("boolean"!=typeof n.loop&&n.loop--,!Array.isArray(t))return console.warn("Chain array is not defined!"),!1;t.reduce((function(t,e){return t.then((function(){return"function"==typeof n.onChainItem&&n.onChainItem(e),animate(e).then((function(){"function"==typeof n.onChainItemComplete&&n.onChainItemComplete(e)}))}))}),Promise.resolve()).then((function(){"function"==typeof n.onChainComplete&&n.onChainComplete(),n.loop&&chain(t,n)}))},stop:stopAnimation,stopAll:function stopAnimationAll(t,e){$.each($.animation.elements,(function(i,o){e?"string"==typeof e?n.call(o.element,e)&&stopAnimation(i,t):e.length?$.each(e,(function(){o.element===this&&stopAnimation(i,t)})):e instanceof Element&&o.element===e&&stopAnimation(i,t):stopAnimation(i,t)}))},resume:resumeAnimation,resumeAll:function resumeAnimationAll(t){$.each($.animation.elements,(function(e,i){t?"string"==typeof t?n.call(i.element,t)&&resumeAnimation(e):t.length?$.each(t,(function(){i.element===this&&resumeAnimation(e)})):t instanceof Element&&i.element===t&&resumeAnimation(e):resumeAnimation(e)}))},pause:pauseAnimation,pauseAll:function pauseAnimationAll(t){$.each($.animation.elements,(function(e,i){t?"string"==typeof t?n.call(i.element,t)&&pauseAnimation(e):t.length?$.each(t,(function(){i.element===this&&pauseAnimation(e)})):t instanceof Element&&i.element===t&&pauseAnimation(e):pauseAnimation(e)}))}}),$.fn.extend({animate:function(t){var e,n,i,o,r=this,a=t;return!Array.isArray(t)&&(arguments.length>1||1===arguments.length&&void 0===arguments[0].draw)?(e=arguments[0],n=arguments[1]||$.animation.duration,i=arguments[2]||$.animation.ease,o=arguments[3],"function"==typeof n&&(o=n,n=$.animation.duration,i=$.animation.ease),"function"==typeof i&&(o=i,i=$.animation.ease),this.each((function(){return $.animate({el:this,draw:e,dur:n,ease:i,onDone:o})}))):Array.isArray(t)?($.each(t,(function(){var t=this;r.each((function(){t.el=this,$.animate(t)}))})),this):this.each((function(){a.el=this,$.animate(a)}))},chain:function(t,e){return this.each((function(){var n=this;$.each(t,(function(){this.el=n})),$.chain(t,e)}))},stop:function(t){return this.each((function(){var e=this;$.each($.animation.elements,(function(n,i){i.element===e&&stopAnimation(n,t)}))}))},pause:function(){return this.each((function(){var t=this;$.each($.animation.elements,(function(e,n){n.element===t&&pauseAnimation(e)}))}))},resume:function(){return this.each((function(){var t=this;$.each($.animation.elements,(function(e,n){n.element===t&&resumeAnimation(e)}))}))}}),$.extend({hidden:function(t,e,n){return t=$(t)[0],"string"==typeof e&&(e="true"===e.toLowerCase()),"function"==typeof e&&(n=e,e=!t.hidden),t.hidden=e,"function"==typeof n&&($.bind(n,t),n.call(t,arguments)),this},hide:function(t,e){var n=$(t),i=t.style.display;t.style.display="";var o=getComputedStyle(t,null).display;return n.origin("display",{display:i,cssDisplay:o}),t.style.display="none","function"==typeof e&&($.bind(e,t),e.call(t,arguments)),this},show:function(t,e){var n=$(t),i=n.origin("display");return i?(i.cssDisplay&&n.css({display:i.cssDisplay}),!i.cssDisplay&&i.display&&(t.style.display="none"===i.display?"block":i.display)):t.style.display="block",0===parseInt(t.style.opacity)&&(t.style.opacity="1"),"function"==typeof e&&($.bind(e,t),e.call(t,arguments)),this},visible:function(t,e,n){return void 0===e&&(e=!0),t.style.visibility=e?"visible":"hidden","function"==typeof n&&($.bind(n,t),n.call(t,arguments)),this},toggle:function(t,e){var n="none"!==getComputedStyle(t,null).display?"hide":"show";return $[n](t,e)}}),$.fn.extend({hide:function(){var t;return $.each(arguments,(function(){"function"==typeof this&&(t=this)})),this.each((function(){$.hide(this,t)}))},show:function(){var t;return $.each(arguments,(function(){"function"==typeof this&&(t=this)})),this.each((function(){$.show(this,t)}))},visible:function(t,e){return this.each((function(){$.visible(this,t,e)}))},toggle:function(t){return this.each((function(){$.toggle(this,t)}))},hidden:function(t,e){return this.each((function(){$.hidden(this,t,e)}))}}),$.extend({fx:{off:!1}}),$.fn.extend({fadeIn:function(t,e,n){return this.each((function(){var i=this,o=$(i),r=!(!isVisible(i)||isVisible(i)&&0==+o.style("opacity"));if(not(t)&&not(e)&&not(n)?(n=null,t=$.animation.duration):"function"==typeof t&&(n=t,t=$.animation.duration),"function"==typeof e&&(n=e,e=$.animation.ease),$.fx.off&&(t=0),r)return"function"==typeof n&&$.proxy(n,this)(),this;var a=o.origin("display",void 0,"block");return i.style.opacity="0",i.style.display=a,$.animate({el:i,draw:{opacity:1},dur:t,ease:e,onDone:function(){"function"==typeof n&&$.proxy(n,this)()}})}))},fadeOut:function(t,e,n){return this.each((function(){var i=this,o=$(i);return not(t)&&not(e)&&not(n)?(n=null,t=$.animation.duration):"function"==typeof t&&(n=t,t=$.animation.duration),"function"==typeof e&&(n=e,e=$.animation.ease),o.origin("display",o.style("display")),isVisible(i)?$.animate({el:i,draw:{opacity:0},dur:t,ease:e,onDone:function(){this.style.display="none","function"==typeof n&&$.proxy(n,this)()}}):("function"==typeof n&&$.proxy(n,this)(),this)}))},slideUp:function(t,e,n){return this.each((function(){var i,o=this,r=$(o);if(0!==r.height())return not(t)&&not(e)&&not(n)?(n=null,t=$.animation.duration):"function"==typeof t&&(n=t,t=$.animation.duration),"function"==typeof e&&(n=e,e=$.animation.ease),i=r.height(),r.origin("height",i),r.origin("display",$(o).style("display")),r.css({overflow:"hidden"}),$.animate({el:o,draw:{height:0},dur:t,ease:e,onDone:function(){r.hide().removeStyleProperty("overflow, height"),"function"==typeof n&&$.proxy(n,this)()}})}))},slideDown:function(t,e,n){return this.each((function(){var i,o,r=this,a=$(r);return not(t)&&not(e)&&not(n)?(n=null,t=$.animation.duration):"function"==typeof t&&(n=t,t=$.animation.duration),"function"==typeof e&&(n=e,e=$.animation.ease),a.show().visible(!1),i=+a.origin("height",void 0,a.height()),0===parseInt(i)&&(i=r.scrollHeight),o=a.origin("display",a.style("display"),"block"),a.height(0).visible(!0),a.css({overflow:"hidden",display:"none"===o?"block":o}),$.animate({el:r,draw:{height:i},dur:t,ease:e,onDone:function(){$(r).removeStyleProperty("overflow, height, visibility"),"function"==typeof n&&$.proxy(n,this)()}})}))},moveTo:function(t,e,n,i,o){var r={top:e,left:t};return"function"==typeof n&&(o=n,n=$.animation.duration,i=$.animation.ease),"function"==typeof i&&(o=i,i=$.animation.ease),this.each((function(){$.animate({el:this,draw:r,dur:n,ease:i,onDone:o})}))},centerTo:function(t,e,n,i,o){return"function"==typeof n&&(o=n,n=$.animation.duration,i=$.animation.ease),"function"==typeof i&&(o=i,i=$.animation.ease),this.each((function(){var r={left:t-this.clientWidth/2,top:e-this.clientHeight/2};$.animate({el:this,draw:r,dur:n,ease:i,onDone:o})}))},colorTo:function(t,e,n,i){var o={color:t};return"function"==typeof e&&(i=e,e=$.animation.duration,n=$.animation.ease),"function"==typeof n&&(i=n,n=$.animation.ease),this.each((function(){$.animate({el:this,draw:o,dur:e,ease:n,onDone:i})}))},backgroundTo:function(t,e,n,i){var o={backgroundColor:t};return"function"==typeof e&&(i=e,e=$.animation.duration,n=$.animation.ease),"function"==typeof n&&(i=n,n=$.animation.ease),this.each((function(){$.animate({el:this,draw:o,dur:e,ease:n,onDone:i})}))}}),$.init=function(t,e){var n,i=this;if("string"==typeof t&&(t=t.trim()),this.uid=$.uniqueId(),!t)return this;if("function"==typeof t)return $.ready(t);if(t instanceof Element)return this.push(t),this;if(t instanceof $)return $.each(t,(function(){i.push(this)})),this;if("window"===t&&(t=window),"document"===t&&(t=document),"body"===t&&(t=document.body),"html"===t&&(t=document.documentElement),"doctype"===t&&(t=document.doctype),t&&(t.nodeType||t.self===window))return this.push(t),this;if(isArrayLike(t))return $.each(t,(function(){$(this).each((function(){i.push(this)}))})),this;if("string"!=typeof t&&t.self&&t.self!==window)return this;if("#"===t||"."===t)return console.error("Selector can't be # or ."),this;if("@"===t[0])$("[data-role]").each((function(){str2arr($(this).attr("data-role"),",").indexOf(t.slice(1))>-1&&i.push(this)}));else if(1===(n=$.parseHTML(t)).length&&3===n[0].nodeType)try{[].push.apply(this,document.querySelectorAll(t))}catch(t){}else $.merge(this,n);return void 0!==e&&(e instanceof $?this.each((function(){$(e).append(i)})):e instanceof HTMLElement?$(e).append(i):isPlainObject(e)&&$.each(this,(function(){for(var t in e)hasProp(e,t)&&this.setAttribute(t,e[t])}))),this},$.init.prototype=$.fn;var m=window.$;$.Promise=Promise,window.m4q=$,void 0===window.$&&(window.$=$),$.global=function(){m=window.$,window.$=$},$.noConflict=function(){return window.$===$&&(window.$=m),$}}();
